--- a/arch/i386/kernel/setup.c	2006-06-25 03:13:24.000000000 +0200
+++ b/arch/i386/kernel/setup.c	2006-06-25 03:13:50.000000000 +0200
@@ -975,6 +975,10 @@
 	u64 start = s;
 	u64 end = e;
 	int i;
+
+	if (efi_enabled)
+		return 1;
+
 	for (i = 0; i < e820.nr_map; i++) {
 		struct e820entry *ei = &e820.map[i];
 		if (type && ei->type != type)
